
// WrapFractalLand3D.java
// Andrew Davison, April 2005, ad@fivedots.coe.psu.ac.th

/* Generuje fraktálovou krajinu tvořenou sítí čtverců, 
   které jsou otexturovány dle výšky, v níž se nacházejí.

   Krajinu obepínají modré stěny a celá je ponořená do slabého
   osvětlení připomínajícím veřer. Obloha je temně modrá. Vzdálenější
   plochy zamlžuje objekt typu LinearFog.   

   Uživatel prochází krajinou za pomoci podobného
   ovládání jako v ukázkové aplikaci FPShooter3D.
*/


import javax.swing.*;
import java.awt.*;

import com.sun.j3d.utils.universe.*;
import com.sun.j3d.utils.geometry.*;
import javax.media.j3d.*;
import javax.vecmath.*;



public class WrapFractalLand3D extends JPanel
/* Uchovává 3D-fraktální krajinu v kontejneru Swing. */
{
  private final static int PWIDTH = 512;   // velikost panelu
  private final static int PHEIGHT = 512; 

  private static final int BOUNDSIZE = 100;  // větší než virtuální svět

  private Color3f skyColour = new Color3f(0.17f, 0.07f, 0.45f);
     // pro uzly typu Background a LinearFog

  private SimpleUniverse su;
  private BranchGroup sceneBG;
  private BoundingSphere bounds;   // pro uzly prostredí

  private Landscape land;   // pro tvorbu povrchu a stěn


  public WrapFractalLand3D(double flatness)
  {
    setLayout( new BorderLayout() );
    setOpaque( false );
    setPreferredSize( new Dimension(PWIDTH, PHEIGHT));

    GraphicsConfiguration config =
					SimpleUniverse.getPreferredConfiguration();
    Canvas3D canvas3D = new Canvas3D(config);
    add("Center", canvas3D);
    canvas3D.setFocusable(true);   
    canvas3D.requestFocus();
    su = new SimpleUniverse(canvas3D);

    createSceneGraph(flatness);
    createUserControls();

    su.addBranchGraph( sceneBG );
  } // konec metody: WrapFractalLand3D()


  void createSceneGraph(double flatness) 
  // inicializuje scénu
  { 
    sceneBG = new BranchGroup();
    bounds = new BoundingSphere(new Point3d(0,0,0), BOUNDSIZE);

    lightScene();     // přidej světla
    addBackground();  // přidej oblohu
    addFog();         // přidej mlhu; comment this line out to vypnout fog
    
    // vytvoř krajinu: podlahu a stěny
    land = new Landscape(flatness);
    sceneBG.addChild( land.getLandBG() );   

    sceneBG.compile();   // zafixuj scénu
  } // konec metody: createScene()


  private void lightScene()
  // jedno směrové světlo
  { Color3f white = new Color3f(1.0f, 1.0f, 1.0f);

    Vector3f lightDir = new Vector3f(1.0f, -1.0f, -0.8f); // nahoře vlevo
    DirectionalLight light1 = 
            new DirectionalLight(white, lightDir);
    light1.setInfluencingBounds(bounds);
    sceneBG.addChild(light1);
  }  // konec metody: lightScene()


  private void addBackground()
  // obloha za soumraku
  { Background back = new Background();
    back.setApplicationBounds( bounds );
    back.setColor( skyColour );   // temně modrá
    sceneBG.addChild( back );
  }  // konec metody: addBackground()

  
  private void addFog()
  // lineární mlha
  { LinearFog fogLinear = new LinearFog( skyColour, 15.0f, 30.0f);
    fogLinear.setInfluencingBounds( bounds );  // stejně jako v případě pozadí
    sceneBG.addChild( fogLinear );
  }  // konec metody: addFog()


  // ---------------------- ovládací prvky uživatele --------------------------


  private void createUserControls()
  /* Upraví ořezávací vzdálenosti a připraví objekt typu KeyBehavior.
     Objekt chování pak inicializuje výhled v počátku roviny XZ.
  */
  {
    // původní hodnoty ořezání: 10 a 0.1; udržuj poměr mezi 100-1000
    View view = su.getViewer().getView();
    view.setBackClipDistance(20);      // můžeme vidět hodně daleko
    view.setFrontClipDistance(0.05);   // můžeme vidět blízské objekty

    ViewingPlatform vp = su.getViewingPlatform();
    TransformGroup steerTG = vp.getViewPlatformTransform();

    // připrav ovládací prvky klávesnice (and position viewpoint)
    KeyBehavior keybeh = new KeyBehavior(land, steerTG);
    keybeh.setSchedulingBounds(bounds);
    vp.setViewPlatformBehavior(keybeh);
  } // konec metody: createUserControls()


} // konec třídy: WrapFractalLand3D